unit CADInspUnit;

interface                       

uses
  Windows, Messages, SysUtils,  Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, InspCtrl, CompInsp, ExtCtrls,cad,TypInfo, ComCtrls;

type
  TCADInspFrm = class(TForm)
    Panel1: TPanel;
    CloseBtn: TButton;
    ComponentInspector1: TComponentInspector;
    Panel2: TPanel;
    ComponentComboBox1: TComponentComboBox;
    procedure ComponentInspector1SetValue(Sender: TObject; TheIndex: Integer; var Value: String; var EnableDefault: Boolean);
    function ComponentInspector1CallEditor(Sender: TObject;
      TheIndex: Integer; var EnableDefault: Boolean): Boolean;
    procedure ComponentInspector1GetButtonType(Sender: TObject;
      TheIndex: Integer; var Value: TButtonType);
    procedure ComponentInspector1GetEnableExternalEditor(Sender: TObject;
      TheIndex: Integer; var Value: Boolean);
    procedure FormActivate(Sender: TObject);
    procedure ComponentComboBox1Change(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure ComponentInspector1GetValue(Sender: TObject;
      TheIndex: Integer; var Value: String);
    procedure ComponentComboBox1Filter(Sender: TObject;
      AComponent: TComponent; var EnableAdd: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  CADInspFrm: TCADInspFrm;

implementation

{$R *.dfm}
uses MainUnit;

procedure TCADInspFrm.ComponentInspector1SetValue(Sender: TObject;
  TheIndex: Integer; var Value: String; var EnableDefault: Boolean);
begin
 Mainfrm.MyCAD1.Invalidate
end;

function TCADInspFrm.ComponentInspector1CallEditor(Sender: TObject;   TheIndex: Integer; var EnableDefault: Boolean): Boolean;
var
  OldValue: string;
begin
 Result:=False;
  with ComponentInspector1 do
    if Assigned(Properties[TheIndex]) then
      with Properties[TheIndex] do
        if TypeKind in [tkString,tkWString,tkLString] then
        begin
          EnableDefault:=False;
          OldValue:=AsString;
          AsString:=InputBox(ComponentInspector1.Instance.Name,Name,OldValue);
          Result:=AsString<>OldValue;
          if Result then Mainfrm.MyCAD1.Invalidate
        end;

end;

procedure TCADInspFrm.ComponentInspector1GetButtonType(Sender: TObject;
  TheIndex: Integer; var Value: TButtonType);
begin
  with ComponentInspector1 do
    if Assigned(Properties[TheIndex]) then
      with Properties[TheIndex] do
        if (TypeKind in [tkString,tkWString,tkLString]) and
          (Value=btNone) then Value:=btDialog;

end;

procedure TCADInspFrm.ComponentInspector1GetEnableExternalEditor(
  Sender: TObject; TheIndex: Integer; var Value: Boolean);
begin

 with ComponentInspector1 do
    if Assigned(Properties[TheIndex]) then
    begin
      with Properties[TheIndex] do
        Value:=(TypeKind in [tkString,tkWString,tkLString]) or IsType(TypeInfo(TGraphic))
           or IsType(TypeInfo(TUserData))  or IsType(TypeInfo(TStrings));
    end;

end;

procedure TCADInspFrm.FormActivate(Sender: TObject);
begin
  CADInspFrm.ComponentComboBox1.Root:=MainFrm.MyCAD1;
  if MainFrm.MyCAD1.GetSelectedShape = nil
  then
   CADInspFrm.ComponentComboBox1.instance:=MainFrm.MyCAD1
  else
   CADInspFrm.ComponentComboBox1.instance:=MainFrm.MyCAD1.GetSelectedShape;
  CADInspFrm.ComponentInspector1.Instance:=CADInspFrm.ComponentComboBox1.Instance;
end;

procedure TCADInspFrm.ComponentComboBox1Change(Sender: TObject);
begin
With   ComponentComboBox1 do
begin
if Items.Objects[ItemIndex] is TMyShape then 
MainFrm.MyCAD1.SelectShapeByCode(TMyShape(Items.Objects[ItemIndex]).GetShapeId);
end;
end;

procedure TCADInspFrm.CloseBtnClick(Sender: TObject);
begin
 close;
end;

procedure TCADInspFrm.ComponentInspector1GetValue(Sender: TObject;
  TheIndex: Integer; var Value: String);
begin
     IF   ComponentInspector1.Properties[TheIndex].Name='UserData' THEN
          IF (ComponentInspector1.Properties[TheIndex].AsObject as TUserData).getcount =0 then
           Value:='(Empty)'
           else
        Value:='(Text)';
end;

procedure TCADInspFrm.ComponentComboBox1Filter(Sender: TObject;
  AComponent: TComponent; var EnableAdd: Boolean);
begin
 EnableAdd:=false;
   IF AComponent IS TMyCAD THEN
   BEGIN
   EnableAdd:=true;

   END;
   IF AComponent IS TMyShape THEN

   If MainFrm.MonitorParentShapesOnly THEN
    BEGIN
        If (NOT ((AComponent As  TMyShape).HasParentShape)) THEN  EnableAdd :=true;
    END
    ELSE // childshape only , add the brother shapes
    BEGIN
        If  MainFrm.MyCAD1.areTheyBrother ((AComponent As  TMyShape),MainFrm.ASelectedChildShape) THEN
        begin
         EnableAdd :=true;
         end;
    END

end;

end.
