unit CADPreview;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, Math;

type
  TPreviewFrm = class(TForm)
    Panel1: TPanel;
    ComboBox1: TComboBox;
    BitBtn1: TBitBtn;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Label1: TLabel;
    BitBtn3: TBitBtn;
    procedure FormResize(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);

  private
    { Private declarations }

  public
    TheScale: double;
    procedure AdjustPosition;
    { Public declarations }
  end;

var
  PreviewFrm: TPreviewFrm;

implementation

uses MainUnit;

{$R *.dfm}

procedure TPreviewFrm.FormResize(Sender: TObject);
begin
  ComboBox1Change(Sender);
end;

procedure TPreviewFrm.AdjustPosition;
begin
  Scrollbox1.HorzScrollBar.Position := 0;
  Scrollbox1.VertScrollBar.Position := 0;

  PreviewFrm.Image1.Width := PreviewFrm.Image1.picture.Bitmap.width;
  PreviewFrm.Image1.Height := PreviewFrm.Image1.picture.Bitmap.Height;
  if Image1.Width < ScrollBox1.Width then
    Image1.Left := (ScrollBox1.Width - Image1.Width) div 2
  else
    Image1.Left := 0;

  if Image1.Height < ScrollBox1.Height then
    Image1.Top := (ScrollBox1.Height - Image1.Height) div 2
  else
    Image1.Top := 0;

  Scrollbox1.HorzScrollBar.Range := max(Image1.Width, ScrollBox1.Width);
  Scrollbox1.VertScrollBar.Range := max(Image1.Height, ScrollBox1.Height);

  Scrollbox1.ScrollInView(Image1);
end;

procedure TPreviewFrm.ComboBox1Change(Sender: TObject);
var
  ScaleX, ScaleY: double;
begin

  with ComboBox1 do
  begin
    case ItemIndex of
      0: TheScale := 0.5;
      1: TheScale := 1.0;
      2: TheScale := 1.5;
      3: TheScale := 2.0;
      4: {Page Width}
        TheScale := ScrollBox1.Width / MainFrm.mycad1.width;
      5: {Whole Page}
        begin
          ScaleX := ScrollBox1.Width / MainFrm.mycad1.Width;
          ScaleY := ScrollBox1.Height / MainFrm.mycad1.Height;
          if (ScaleX <= ScaleY) then
            TheScale := ScaleX
          else
            TheScale := ScaleY;
        end;

      6: TheScale := 1.0;
    end;

   MainFrm.MyCAD1.PrintPreview([],PreviewFrm.Image1.picture.Bitmap,TheScale);
   PreViewFrm.AdjustPosition;
  end;
end;

procedure TPreviewFrm.BitBtn1Click(Sender: TObject);
begin
  MainFrm.mycad1.Print([],1.0);
  
end;

procedure TPreviewFrm.BitBtn3Click(Sender: TObject);
begin
  MainFrm.mycad1.Print([MainFrm.MyCAD1.CurrentLayerId], 1.0);

end;

end.

